summaryrefslogtreecommitdiffstats
path: root/package/ltq-dsl-app/files/dsl_notify.sh
diff options
context:
space:
mode:
authorblogic <blogic@3c298f89-4303-0410-b956-a3cf2f4a3e73>2012-01-24 11:31:23 +0000
committerblogic <blogic@3c298f89-4303-0410-b956-a3cf2f4a3e73>2012-01-24 11:31:23 +0000
commit39caa68329ed3f33188869183a58b03bc1583642 (patch)
treee7ac366672869c4a613cc7f0c8dfcceeeff3563c /package/ltq-dsl-app/files/dsl_notify.sh
parent3ea7ce520057866773484edb1d6928f98665378e (diff)
[lantiq] Initial DSL framework
- Removed ifx_cpe_control_init.sh (the old init script) - Created dsl_control (/etc/init.d) - tidied up start and stop - stop calls dsl_notify before killing daemon - has status and lucistat options to provide detail - copes with daemon not running situation - Updated package makefile to use new init script and to build cli support - Provide a dsl_notify.sh script to cope with line up/down events Signed-off-by: Lee Essen <lee.essen@nowonline.co.uk> git-svn-id: svn://svn.openwrt.org/openwrt/trunk@29881 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/ltq-dsl-app/files/dsl_notify.sh')
-rw-r--r--package/ltq-dsl-app/files/dsl_notify.sh44
1 files changed, 44 insertions, 0 deletions
diff --git a/package/ltq-dsl-app/files/dsl_notify.sh b/package/ltq-dsl-app/files/dsl_notify.sh
new file mode 100644
index 000000000..f440450f0
--- /dev/null
+++ b/package/ltq-dsl-app/files/dsl_notify.sh
@@ -0,0 +1,44 @@
+#!/bin/sh
+#
+# This script is called by dsl_cpe_control whenever there is a DSL event,
+# we only actually care about the DSL_INTERFACE_STATUS events as these
+# tell us the line has either come up or gone down.
+#
+# The rest of the code is basically the same at the atm hotplug code
+#
+
+[ "$DSL_NOTIFICATION_TYPE" = "DSL_INTERFACE_STATUS" ] || exit 0
+
+. /etc/functions.sh
+
+include /lib/network
+scan_interfaces
+
+local found=0
+local ifc
+for ifc in $interfaces; do
+ local up
+ config_get_bool up "$ifc" up 0
+
+ local auto
+ config_get_bool auto "$ifc" auto 1
+
+ local proto
+ config_get proto "$ifc" proto
+
+ if [ "$DSL_INTERFACE_STATUS" = "UP" ]; then
+ if [ "$proto" = "pppoa" ] && [ "$up" != 1 ] && [ "$auto" = 1 ]; then
+ found=1
+ ( sleep 1; ifup "$ifc" ) &
+ fi
+ else
+ if [ "$proto" = "pppoa" ] && [ "$up" = 1 ] && [ "$auto" = 1 ]; then
+ found=1
+ ( sleep 1; ifdown "$ifc" ) &
+ fi
+ fi
+done
+
+if [ "$found" != 1 ]; then
+ logger "Found no matching interface for DSL notification ($DSL_INTERFACE_STATUS)"
+fi